aboutsummaryrefslogtreecommitdiff
path: root/testsuite/grep.tests
diff options
context:
space:
mode:
authorBernhard Reutner-Fischer <rep.dot.nop@gmail.com>2005-09-23 15:44:46 +0000
committerBernhard Reutner-Fischer <rep.dot.nop@gmail.com>2005-09-23 15:44:46 +0000
commitb47a74f4e773dee93c60116dd34c002c7c118d0b (patch)
tree7adcb31fbbb5e204ab577cbe31c2f72cb3b5387f /testsuite/grep.tests
parent0a44c1777134281be6b00c69b8d6b8668ea1dbf9 (diff)
downloadbusybox-b47a74f4e773dee93c60116dd34c002c7c118d0b.tar.gz
- introduce variable _BB_CONFIG_DEP to the new test harness.
This is used to see if given tests should be run (are available) or not. Print "UNTESTED: descr" if the applet or feature is not available. - add _BB_CONFIG_DEP to existing new.tests - move old grep test to new test infrastructure and add a few more test for grep.
Diffstat (limited to 'testsuite/grep.tests')
-rw-r--r--testsuite/grep.tests82
1 files changed, 82 insertions, 0 deletions
diff --git a/testsuite/grep.tests b/testsuite/grep.tests
new file mode 100644
index 000000000..c4f534d1a
--- /dev/null
+++ b/testsuite/grep.tests
@@ -0,0 +1,82 @@
+#!/bin/sh
+
+# grep tests.
+# Copyright 2005 by Rob Landley <rob@landley.net>
+# Licensed under GPL v2, see file LICENSE for details.
+
+# AUDIT:
+
+[ ${#COMMAND} -eq 0 ] && COMMAND=grep
+. testing.sh
+
+# Depends on grep
+_BB_CONFIG_DEP=grep
+
+# testing "test name" "options" "expected result" "file input" "stdin"
+# file input will be file called "input"
+# test can create a file "actual" instead of writing to stdout
+
+# Test exit status
+
+testing "grep (exit with error)" "nonexistent 2> /dev/null ; echo \$?" \
+ "1\n" "" ""
+testing "grep (exit success)" "grep $0 > /dev/null 2>&1 ; echo \$?" "0\n" \
+ "" ""
+# Test various data sources and destinations
+
+testing "grep (default to stdin)" "two" "two\n" "" \
+ "one\ntwo\nthree\nthree\nthree\n"
+testing "grep - (specify stdin)" "two -" "two\n" "" \
+ "one\ntwo\nthree\nthree\nthree\n"
+testing "grep input (specify file)" "two input" "two\n" \
+ "one\ntwo\nthree\nthree\nthree\n" ""
+
+# Note that this assumes actual is empty.
+testing "grep input actual (two files)" "two input actual 2> /dev/null" \
+ "input:two\n" "one\ntwo\nthree\nthree\nthree\n" ""
+
+testing "grep - infile (specify stdin and file)" "two - input" \
+ "(standard input):two\ninput:two\n" "one\ntwo\nthree\n" \
+ "one\ntwo\ntoo\nthree\nthree\n"
+
+# Check if we see the correct return value if both stdin and non-existing file
+# are given.
+testing "grep - nofile (specify stdin and nonexisting file)" \
+ "two - nonexistent 2> /dev/null ; echo \$?" \
+ "(standard input):two\n(standard input):two\n2\n" \
+ "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+testing "grep -q - nofile (specify stdin and nonexisting file, no match)" \
+ "-q nomatch - nonexistent 2> /dev/null ; echo \$?" \
+ "2\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+# SUSv3: If the -q option is specified, the exit status shall be zero
+# if an input line is selected, even if an error was detected.
+testing "grep -q - nofile (specify stdin and nonexisting file, match)" \
+ "-q two - nonexistent ; echo \$?" \
+ "0\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+
+# Test various command line options
+# -s no error messages
+testing "grep -s nofile (nonexisting file, no match)" \
+ "-s nomatch nonexistent ; echo \$?" "2\n" "" ""
+testing "grep -s nofile - (stdin and nonexisting file, match)" \
+ "-s domatch nonexistent - ; echo \$?" "(standard input):domatch\n2\n" \
+ "" "nomatch\ndomatch\nend\n"
+
+# This doesn't match GNU behaviour (Binary file input matches)
+# acts like GNU grep -a
+testing "grep handles binary files" "foo input" "foo\n" "\0foo\n\n" ""
+# This doesn't match GNU behaviour (Binary file (standard input) matches)
+# acts like GNU grep -a
+testing "grep handles binary stdin" "foo" "foo\n" "" "\0foo\n\n"
+
+testing "grep matches NUL" ". input > /dev/null 2>&1 ; echo \$?" "0\n" "\0\n" ""
+
+# -e regex
+testing "grep handles multiple regexps" "-e one -e two input ; echo \$?" \
+ "one\ntwo\n0\n" "one\ntwo\n" ""
+
+# Depends on FEATURE_GREP_EGREP_ALIAS
+_BB_CONFIG_DEP=FEATURE_GREP_EGREP_ALIAS
+testing "grep -E supports extended regexps" "-E fo+" "foo\n" "" "b\ar\nfoo\nbaz"
+
+exit $FAILCOUNT